%define kmodtool sh %{SOURCE49}
%define	kmod_name xenpv
%define kverrel %(%{kmodtool} verrel 2>/dev/null)
# Note: if mock build fails(check root.log), 
# check version of rhel3 being used to build kernel modules 
# and replace the rev below with the matching one
%define kverrel 2.4.21-52.EL
%define kverbase 2.4.21

# hardcode for now 
%define kvariants ""
%define kbuilddep kernel-source

%ifarch i686
%define kvariants "" smp hugemem
%endif

%ifarch x86_64
%define kvariants "" smp
%endif

%ifarch ia64
%define kvariants "" smp
%endif

%ifarch athlon
%define kvariants "" smp
%endif

%ifarch ia32e
%define kvariants ""
%endif

%define xen_src_rev 3.1.0 

Name: xenpv 
License: GPL
Group: System Environment/Kernel
Summary: xen paravirtual drivers for RHEL-3
Version: 0.1
Release: 9.el3
Source0: xen-%{xen_src_rev}-src.tgz
Source1: xenpv.modprobe
Source3: README.el3
#Source40: xenpv.rhel4.hotplug.agent
Source49: xenpv-kmodtool-el3
#ExclusiveArch:	i686 x86_64 ia64 athlon ia32e
ExclusiveArch:	i686 x86_64 athlon ia32e


# rhel-3 patches
Patch1: %kmod_name-balloon-compat.patch
Patch2: %kmod_name-blkfront.patch
Patch3: %kmod_name-drivers-compat.patch
Patch4: %kmod_name-gnttab.patch
Patch5: %kmod_name-hypercall-pgtable-includes.patch
Patch6: %kmod_name-includes.patch
Patch7: %kmod_name-netfront.patch
Patch8: %kmod_name-mkbuildtree.patch

# ported rhel-5 fixes
#Patch10:  %kmod_name-buildfix.patch
#Patch11:  %kmod_name-nosysfs.patch
#Patch12:  %kmod_name-noxen.patch
Patch13:  %kmod_name-initrace.patch
Patch14:  %kmod_name-smprace.patch
Patch15:  %kmod_name-skb-useafterfree.patch
#Patch16:  %kmod_name-ia64-balloon.patch -- part of drivers-compat.patch
Patch17:  %kmod_name-ia64-isairq.patch
Patch18: %kmod_name-kzalloc-watch.patch
Patch19: %kmod_name-signal-guest-panic.patch

# ressource allocation bits
# Patch20:  %kmod_name-res-rtl8139.patch
# Patch21:  %kmod_name-res-piix.patch

# module autoloading
# Patch30:  %kmod_name-autoload.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: kernel %kbuilddep

%description
xen paravirtual drivers for Linux Full-Virt/HVM guests

%define kmp_version %{version}
%define kmp_release %{release}
%{expand:%(%{kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%prep
%setup -q -c

cd xen-%{xen_src_rev}-src

%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1

#%patch10 -p1
#%patch11 -p1
#%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
#%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1

#%patch20 -p1
#%patch21 -p1
#%patch30 -p1
set -- *
mkdir source
mv "$@" source/
mkdir source/kernel

%build
ksrc=%{_usrsrc}/linux-2.4
# ok, now, to get to building pv-on-hvm drivers...
cd xen-%{xen_src_rev}-src
xensrc=$PWD
for flavor in %kvariants; do
	#
	# There is no kernel-devel pkg for RHEL-3,
	# only kernel-source, so need to copy kernel
	# tree (due to priv'd access to kernel src)
	# & make oldconfig & make dep, per-kvariant,
	# in order to build modules.
	# 
	echo "### building for '$flavor' variant of kernel ###"
	kdir="kernels/%{kverrel}${flavor:+-$flavor}-%{_target_cpu}"
	rm -rf $kdir
	mkdir -p $kdir
	cd $kdir
	ksrcbuild=$PWD
	cp -rd $ksrc/* . 
        # get rid of 'custom' tag on EXTRAVERSION to make scripts cleaner below
	cp $ksrcbuild/Makefile $ksrcbuild/Makefile.pre-xenpv-orig
	sed -e 's/custom//' $ksrcbuild/Makefile.pre-xenpv-orig > $ksrcbuild/Makefile
	# clean out any old junk
	# make clean  -- not good enough!
	make mrproper > /dev/null
	# copy appropriate config file to seed make oldconfig
	cp -v configs/kernel-%{kverbase}-%{_target_cpu}${flavor:+-$flavor}.config ./.config
	make oldconfig > /dev/null
	# now, make dep; generates a ton of warnings so output error to /dev/null as well
	make dep >& /dev/null
	# finally, onto building xenpv modules
	cd $xensrc
	mdir="obj-$flavor/unmodified_drivers/linux-2.6"
	rm -rf obj-$flavor
	cp -r source obj-$flavor
	(cd $mdir; ./mkbuildtree)
	# next line turned on, following line turned off for build debug
	make -C $ksrcbuild SUBDIRS=$PWD/$mdir modules
	# make %{?_smp_mflags} -C $ksrcbuild SUBDIRS=$PWD/$mdir modules
done

%install
rm -rf %{buildroot}
export INSTALL_MOD_PATH=%{buildroot}
export INSTALL_MOD_DIR=extra/%{kmod_name}/%{version}-%{release}
cd xen-%{xen_src_rev}-src
xensrcdir=$PWD
for flavor in %kvariants; do
	echo "### installing for '$flavor' variant of kernel ###"
	# debug
	#ls
	kdir="kernels/%{kverrel}${flavor:+-$flavor}-%{_target_cpu}"
	cd $xensrcdir/$kdir
	ksrcbuild=$PWD
	mdir="obj-$flavor/unmodified_drivers/linux-2.6"
	make -C $ksrcbuild SUBDIRS=$xensrcdir/$mdir modules_install
	# INSTALL_MOD_DIR not working yet in this kernel version ...
	fix="%{buildroot}/lib/modules/%{kverrel}"
	mkdir -p ${fix}${flavor}/$INSTALL_MOD_DIR
	# copy from non-flavor kernel area to flavor-specific area
	cp -v ${fix}/kernel/Lost/*.o ${fix}${flavor}/$INSTALL_MOD_DIR
	# TODO: -- delete /Lost to make rpm cleaner...
	rm -vrf ${fix}/kernel/Lost
	# todo? rm the build directory ?
done

#
# Need to make an awk/sed script that
# searches for a tag in /etc/modules.conf
# and if tag isn't there, then add stuff from
# SOURCE1 to it
#
#mkdir -p %{buildroot}/etc/modprobe.d
#cp -v %{SOURCE1} %{buildroot}/etc/modprobe.d/xenpv
#mkdir -p %{buildroot}/etc/hotplug
#cp -v %{SOURCE40} %{buildroot}/etc/hotplug/xen.agent
mkdir -p %{buildroot}/usr/share/doc/%{name}-%{version}-%{release}
cp -v %{SOURCE3} %{buildroot}/usr/share/doc/%{name}-%{version}-%{release}/README

# %files
# %defattr(-,root,root)
#%config(noreplace) /etc/modprobe.d/xenpv
# %attr(755,root,root) /etc/hotplug/xen.*
# %doc /usr/share/doc/%{name}-%{version}-%{release}/README

%changelog
* Wed Oct 10 2007 Don Dutile <ddutile@dddesktop0.boston.redhat.com> - 0.1-1.el3
- First version based on Herbert's xenpv-x86_64 tarball, 5/2/07 patch list(for comparison) and some of Gerd's patches from RHEL4/RHEL5 pkg.


